import { Parser } from '../../../types';
import type { QueryCustomType } from '../builder';
import { Renderable } from './syntax';
export declare abstract class Expression<T> implements Renderable {
    protected _children: Renderable[];
    constructor({ children, }?: {
        children?: Renderable[];
    });
    get [Symbol.toStringTag](): string;
    abstract render({ aliases, escape, prefix, parser, }: {
        aliases?: QueryCustomType[];
        escape?: boolean;
        prefix?: string;
        parser?: Parser<T>;
    }): string;
    abstract clone(): Expression<T>;
    children(): Renderable[];
    length(): number;
    toJSON(): {
        children: any[];
    };
}
