import { Parser } from '../../../types';
import type { QueryCustomType } from '../builder';
import { Expression } from './base';
import { ODataFunctions, ODataOperators, Renderable } from './syntax';
export type ComputeExpressionBuilder<T> = {
    t: Required<Readonly<T>>;
    e: () => ComputeExpression<T>;
};
export declare class ComputeExpression<T> extends Expression<T> {
    names: string[];
    constructor({ children, names, }?: {
        children?: Renderable[];
        names?: string[];
    });
    static compute<T>(opts: (builder: ComputeExpressionBuilder<T>, current?: ComputeExpression<T>) => ComputeExpression<T>, current?: ComputeExpression<T>): ComputeExpression<T>;
    render({ aliases, escape, prefix, parser, }?: {
        aliases?: QueryCustomType[];
        escape?: boolean;
        prefix?: string;
        parser?: Parser<T>;
    }): string;
    clone(): ComputeExpression<T>;
    private _add;
    field<T>(name: string, opts: (e: {
        o: ODataOperators<T>;
        f: ODataFunctions<T>;
    }) => Renderable): ComputeExpression<T>;
}
