import { Parser } from '../../../types';
import type { QueryCustomType } from '../builder';
import { Expression } from './base';
import { FilterExpression, FilterExpressionBuilder } from './filter';
import { Renderable } from './syntax';
export declare class CountField<T> implements Renderable {
    protected field: any;
    private values;
    constructor(field: any, values?: {
        [name: string]: any;
    });
    get [Symbol.toStringTag](): string;
    toJSON(): {
        field: any;
    };
    render({ aliases, escape, prefix, parser, }: {
        aliases?: QueryCustomType[];
        escape?: boolean;
        prefix?: string;
        parser?: Parser<T>;
    }): string;
    filter(opts: (builder: FilterExpressionBuilder<T>, current?: FilterExpression<T>) => FilterExpression<T>): any;
    clone(): CountField<T>;
    private option;
}
export type CountExpressionBuilder<T> = {
    t: Readonly<Required<T>>;
    e: () => CountExpression<T>;
};
export declare class CountExpression<T> extends Expression<T> {
    constructor({ children, }?: {
        children?: Renderable[];
    });
    static count<T>(opts: (builder: CountExpressionBuilder<T>, current?: CountExpression<T>) => CountExpression<T>, current?: CountExpression<T>): CountExpression<T>;
    private _add;
    render({ aliases, escape, prefix, parser, }?: {
        aliases?: QueryCustomType[];
        escape?: boolean;
        prefix?: string;
        parser?: Parser<T>;
    }): string;
    clone(): CountExpression<T>;
    field<F>(field: F[], opts?: (e: {
        t: F;
        f: CountField<F>;
    }) => CountExpression<F>): CountExpression<F>;
}
