import { Parser } from '../../../types';
import type { QueryCustomType } from '../builder';
import { Expression } from './base';
import { Renderable } from './syntax';
export declare class OrderByField implements Renderable {
    protected field: Renderable;
    protected order: 'asc' | 'desc';
    constructor(field: Renderable, order: 'asc' | 'desc');
    get [Symbol.toStringTag](): string;
    toJSON(): {
        field: any;
        order: "asc" | "desc";
    };
    render({ aliases, escape, prefix, parser, }: {
        aliases?: QueryCustomType[];
        escape?: boolean;
        prefix?: string;
        parser?: Parser<any>;
    }): string;
    clone(): OrderByField;
}
export type OrderByExpressionBuilder<T> = {
    t: Readonly<Required<T>>;
    e: () => OrderByExpression<T>;
};
export declare class OrderByExpression<T> extends Expression<T> {
    constructor({ children, }?: {
        children?: Renderable[];
    });
    static orderBy<T>(opts: (builder: OrderByExpressionBuilder<T>, current?: OrderByExpression<T>) => OrderByExpression<T>, current?: OrderByExpression<T>): OrderByExpression<T>;
    private _add;
    render({ aliases, escape, prefix, parser, }?: {
        aliases?: QueryCustomType[];
        escape?: boolean;
        prefix?: string;
        parser?: Parser<T>;
    }): string;
    clone(): OrderByExpression<T>;
    ascending(field: any): OrderByExpression<T>;
    descending(field: any): OrderByExpression<T>;
}
