import { Parser } from '../../../types';
import type { QueryCustomType } from '../builder';
import { Expression } from './base';
import { Renderable } from './syntax';
export type SelectExpressionBuilder<T> = {
    t: Readonly<Required<T>>;
    e: () => SelectExpression<T>;
};
export declare class SelectExpression<T> extends Expression<T> {
    constructor({ children, }?: {
        children?: Renderable[];
    });
    static select<T>(opts: (builder: SelectExpressionBuilder<T>, current?: SelectExpression<T>) => SelectExpression<T>, current?: SelectExpression<T>): SelectExpression<T>;
    render({ aliases, escape, prefix, parser, }?: {
        aliases?: QueryCustomType[];
        escape?: boolean;
        prefix?: string;
        parser?: Parser<T>;
    }): string;
    clone(): SelectExpression<T>;
    private _add;
    field(field: any): SelectExpression<T>;
}
